diff -crN nakedmudv1.4/src/magic.c.bk nakedmudv1.5/src/magic.c.bk
*** nakedmudv1.4/src/magic.c.bk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/magic.c.bk	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,572 ----
+ //*****************************************************************************
+ //
+ // magic.c
+ //
+ // A little magic system that has similarities to Richard Bartle's Spellbinder
+ // (http://www.mud.co.uk/richard/spellbnd.htm). Players chain gestures 
+ // together to make magical effects happen. The system is a little bit 
+ // different, in that players have to draw on power from different sources 
+ // (fire, water, earth, air) before they can cast spells. They can combine
+ // powers from different sources to make more elaborate powers (e.g. fire +
+ // earth = magma). Other differences exist; for instance, this magic system
+ // is realtime, whereas Bartle's is turn-based. Characters have to "spend"
+ // and "tap" magic power, whereas in Bartle's game, magic did not have a source
+ // one had to draw into, or magic power one had to spend.
+ //
+ //*****************************************************************************
+ 
+ #include "mud.h"
+ #include "utils.h"
+ #include "event.h"
+ #include "magic.h"
+ #include "character.h"   // send_to_char()
+ #include "handler.h"     // generic_find()
+ #include "inform.h"      // message()
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // local data, structures, and functions
+ //
+ //*****************************************************************************
+ 
+ // how often do we check for mana increases and manaburn?
+ #define MAG_EVENT_DELAY      (5 SECONDS)
+ #define MANABURN_MIN                 5
+ 
+ 
+ //
+ // Where all of our characters and their actions are stored
+ //
+ HASHMAP *mag_map = NULL;
+ 
+ 
+ 
+ //
+ // All of the info we need for keeping track of the magic
+ // status of a character.
+ //
+ typedef struct mag_data {
+   char *lh_actions;  // the movements we've made with our left hand
+   char *rh_actions;  // and with our right hand
+ 
+   char lh_tapping;   // what magic is our left hand tapping?
+   char rh_tapping;   // what magic is our right hand tapping?
+ 
+   int mana_fire;     // how much mana have we accumulated for various elements?
+   int mana_water;    
+   int mana_earth;
+   int mana_air;
+ 
+   int barrier_fire;  // how protected are we from fire damage?
+   int barrier_water;
+   int barrier_earth;
+   int barrier_air;
+ 
+ } MAG_DATA;
+ 
+ 
+ //
+ // create a new magic entry
+ //
+ MAG_DATA *newMagic(void) {
+   MAG_DATA *magic = malloc(sizeof(MAG_DATA));
+   bzero(magic, sizeof(MAG_DATA));
+   magic->lh_actions = strdup("");
+   magic->rh_actions = strdup("");
+   magic->lh_tapping = MAG_ACTION_NONE;
+   magic->rh_tapping = MAG_ACTION_NONE;
+   return magic;
+ }
+ 
+ 
+ //
+ // Delete a magic entry
+ //
+ void deleteMagic(MAG_DATA *magic) {
+   if(magic->lh_actions) free(magic->lh_actions);
+   if(magic->rh_actions) free(magic->rh_actions);
+   free(magic);
+ }
+ 
+ 
+ typedef struct mag_effect {
+   int   effect;          // what effect does it do?
+   int   cost;            // what's the cost in mana?
+   char *hand_movement;   // what is the hand movement?
+ } MAG_EFFECT;
+ 
+ 
+ MAG_EFFECT mag_effects_fire[] = {
+   { MAG_EFFECT_FIREBOLT,    2,           "sf" }, // snap, finger (point)
+   { MAG_EFFECT_NONE,        0,           NULL }  // sentinel
+ };
+ 
+ MAG_EFFECT mag_effects_water[] = {
+   { MAG_EFFECT_ACIDBOLT,    2,           "sf" }, // snap, finger (point)
+   { MAG_EFFECT_NONE,        0,           NULL }  // sentinel
+ };
+ 
+ MAG_EFFECT mag_effects_earth[] = {
+   { MAG_EFFECT_STONESPEAR,  2,           "sf" }, // snap, finger (point)
+   { MAG_EFFECT_NONE,        0,           NULL }  // sentinel
+ };
+ 
+ MAG_EFFECT mag_effects_air[] = {
+   { MAG_EFFECT_SHOCK,       2,           "sf" }, // snap, finger (point)
+   { MAG_EFFECT_NONE,        0,           NULL }  // sentinel
+ };
+ 
+ 
+ 
+ //
+ // get the magic table associated with the mana that has been tapped
+ //
+ MAG_EFFECT *get_mag_table(MAG_DATA *magic) {
+   if(magic->mana_fire > 0 && 
+      magic->mana_water == 0 && magic->mana_earth == 0 && magic->mana_air == 0)
+     return mag_effects_fire;
+   if(magic->mana_water > 0 && 
+      magic->mana_fire == 0 && magic->mana_earth == 0 && magic->mana_air == 0)
+     return mag_effects_water;
+   if(magic->mana_earth > 0 && 
+      magic->mana_water == 0 && magic->mana_fire == 0 && magic->mana_air == 0)
+     return mag_effects_earth;
+   if(magic->mana_air > 0 && 
+      magic->mana_water == 0 && magic->mana_earth == 0 && magic->mana_fire == 0)
+     return mag_effects_air;
+ 
+   return NULL;
+ }
+ 
+ 
+ //
+ // look in the table to see if we've completed any of the actions it has
+ //
+ int check_for_mag_effect(const MAG_EFFECT *mag_effects, 
+ 			 const char *actions) {
+   int i;
+   int act_len = strlen(actions);
+ 
+   // go through our list of effects, and search
+   for(i = 0; mag_effects[i].effect != MAG_EFFECT_NONE; i++) {
+     int move_len = strlen(mag_effects[i].hand_movement);
+ 
+     // make sure we've performed enough actions
+     if(act_len < move_len)
+       continue;
+ 
+     // go in reverse for both of them
+     int j;
+     char *movement = mag_effects[i].hand_movement;
+     for(j = move_len-1; j >= 0; j--)
+       if(movement[j] != actions[act_len-move_len+j])
+ 	break;
+ 
+     // if we got right to the end, we found a match
+     if(j == -1)
+       break;
+   }
+ 
+   return i;
+ }
+ 
+ const char *mag_hand_name(char hand) {
+   return (hand == MAG_HAND_LEFT ? "left" :
+ 	  (hand == MAG_HAND_RIGHT ? "right" : "BUG"));
+ }
+ 
+ const char *mag_tap_name(char tap_type) {
+   return (tap_type == MAG_ACTION_TAP_FIRE ? "fire" :
+ 	  (tap_type == MAG_ACTION_TAP_WATER ? "water" :
+ 	   (tap_type == MAG_ACTION_TAP_EARTH ? "earth" :
+ 	    (tap_type == MAG_ACTION_TAP_AIR ? "air" : "BUG"))));
+ }
+ 
+ const char *mag_tap_color(char tap_type) {
+   return (tap_type == MAG_ACTION_TAP_FIRE ? "red" :
+ 	  (tap_type == MAG_ACTION_TAP_WATER ? "blue" :
+ 	   (tap_type == MAG_ACTION_TAP_EARTH ? "brown" :
+ 	    (tap_type == MAG_ACTION_TAP_AIR ? "white" : "BUG"))));
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementation of magic.h
+ //
+ //*****************************************************************************
+ 
+ void init_magic() {
+   // use standard hashing function and comparator
+   mag_map = newHashmap(NULL, NULL, 50);
+ }
+ 
+ 
+ //
+ // Check if the magic is involved in an event. Basically, straight comparison
+ //
+ int check_mag_event_involvement(void *thing, MAG_DATA *magic) {
+   return (thing == magic);
+ }
+ 
+ 
+ //
+ // Inform the character (and room) that the character has lost his
+ // connection to a mana source
+ //
+ void magic_stop_message(CHAR_DATA *ch, char tap_type) {
+   send_to_char(ch, "Your connection with the plane of %s is cut short.\r\n",
+ 	       mag_tap_name(tap_type));
+   message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR, 
+ 	  "The %s aura around $n's body wanes.", mag_tap_color(tap_type));
+ }
+ 
+ 
+ //
+ // Inform the character (and room) that the character has begun tapping mana
+ //
+ void tap_start_message(CHAR_DATA *ch, char hand, char tap_type) {
+   send_to_char(ch, 
+ 	       "You begin tapping into the plane of %s with your %s hand.\r\n",
+ 	       mag_tap_name(tap_type), mag_hand_name(hand));
+   message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	  "$n upraises $s %s palm, and it becomes shrouded in a %s aura.",
+ 	  mag_hand_name(hand), mag_tap_color(tap_type));
+ }
+ 
+ 
+ //
+ // Inform the character (and room) that the character has begun tapping mana
+ //
+ void tap_stop_message(CHAR_DATA *ch, char hand, char tap_type) {
+   send_to_char(ch, 
+ 	       "You stop tapping into the plane of %s with your %s hand.\r\n",
+ 	       mag_tap_name(tap_type), mag_hand_name(hand));
+   message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
+ 	  "$n lowers $s %s palm, and the %s aura around it dims slightly.",
+ 	  mag_hand_name(hand), mag_tap_color(tap_type));
+ }
+ 
+ 
+ //
+ // Update the magic status (increasing mana, giving manaburn, etc...) and
+ // throw it back into the event handler
+ //
+ void handle_mag_event(CHAR_DATA *ch, MAG_DATA *magic, const char *arg) {
+   // up our mana by 2 and decrease our mana reserves by 1
+   // essentially, this results in +1 mana when we are actively tapping
+   // a manasource (+3 if we are tapping with both hands) and -1 if we
+   // are not tapping.
+   magic->mana_fire  += 2*((magic->lh_tapping == MAG_ACTION_TAP_FIRE) + 
+ 			  (magic->rh_tapping == MAG_ACTION_TAP_FIRE));
+   magic->mana_water += 2*((magic->lh_tapping == MAG_ACTION_TAP_WATER) +
+ 			  (magic->rh_tapping == MAG_ACTION_TAP_WATER));
+   magic->mana_earth += 2*((magic->lh_tapping == MAG_ACTION_TAP_EARTH) +
+ 			  (magic->rh_tapping == MAG_ACTION_TAP_EARTH));
+   magic->mana_air   += 2*((magic->lh_tapping == MAG_ACTION_TAP_AIR) +
+ 			  (magic->rh_tapping == MAG_ACTION_TAP_AIR));
+ 
+   if(magic->mana_fire > 0) {
+     magic->mana_fire--;
+     if(magic->mana_fire == 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_FIRE);
+   }
+ 
+   if(magic->mana_water > 0) {
+     magic->mana_water--;
+     if(magic->mana_water == 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_WATER);
+   }
+ 
+   if(magic->mana_earth > 0) {
+     magic->mana_earth--;
+     if(magic->mana_water == 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_EARTH);
+   }
+ 
+   if(magic->mana_air > 0) {
+     magic->mana_air--;
+     if(magic->mana_air == 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_AIR);
+   }
+ 
+ 
+   // send increase messages
+   if(magic->lh_tapping == MAG_ACTION_TAP_FIRE || magic->rh_tapping == MAG_ACTION_TAP_FIRE)
+     send_to_char(ch, "You tap into a little bit of fire mana.\r\n");
+   if(magic->lh_tapping == MAG_ACTION_TAP_WATER || magic->rh_tapping == MAG_ACTION_TAP_WATER)
+     send_to_char(ch, "You tap into a little bit of water mana.\r\n");
+   if(magic->lh_tapping == MAG_ACTION_TAP_EARTH || magic->rh_tapping == MAG_ACTION_TAP_EARTH)
+     send_to_char(ch, "You tap into a little bit of earth mana.\r\n");
+   if(magic->lh_tapping == MAG_ACTION_TAP_AIR || magic->rh_tapping == MAG_ACTION_TAP_AIR)
+     send_to_char(ch, "You tap into a little bit of air mana.\r\n");
+ 
+ 
+   // check for manaburn -> when people accumulate too much mana
+   //***********
+   // FINISH ME
+   //***********
+ 
+ 
+   // now, put it back in the event queue
+   start_event(ch, MAG_EVENT_DELAY, 
+ 	      handle_mag_event, check_mag_event_involvement, 
+ 	      magic, NULL);
+ }
+ 
+ 
+ void interrupt_magic(CHAR_DATA *ch) {
+   // see if the character has a magic entry.
+   MAG_DATA *magic = mapGet(mag_map, ch);
+ 
+   // if he does, interrupt all actions involving this magic entry
+   if(magic) { 
+     interrupt_events_involving(magic);
+ 
+     // and let the character know
+     if(magic->mana_fire > 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_FIRE);
+     if(magic->mana_water > 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_WATER);
+     if(magic->mana_earth > 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_EARTH);
+     if(magic->mana_air > 0)
+       magic_stop_message(ch, MAG_ACTION_TAP_AIR);
+ 
+     // and finally, delete the magic entry
+     deleteMagic(magic);
+   }
+ }
+ 
+ 
+ //
+ // return true if the action is mana-tapping-oriented
+ //
+ bool mag_action_is_tap(char action) {
+   return (action == MAG_ACTION_TAP_FIRE  || action == MAG_ACTION_TAP_AIR   ||
+ 	  action == MAG_ACTION_TAP_WATER || action == MAG_ACTION_TAP_EARTH);
+ }
+ 
+ 
+ //
+ // Set a character to start tapping in one hand
+ //
+ void start_tapping(CHAR_DATA *ch, MAG_DATA *magic, char hand, char action) {
+   if(hand == MAG_HAND_LEFT) {
+     magic->lh_tapping = action;
+     tap_start_message(ch, hand, action);
+   }
+   else if(hand == MAG_HAND_RIGHT) {
+     magic->rh_tapping = action;
+     tap_start_message(ch, hand, action);
+   }
+ }
+ 
+ 
+ //
+ // Stop a character tapping in one hand
+ //
+ void stop_tapping(CHAR_DATA *ch, MAG_DATA *magic, char hand) {
+   if(hand == MAG_HAND_LEFT) {
+     tap_stop_message(ch, hand, magic->lh_tapping);
+     magic->lh_tapping = MAG_ACTION_NONE;
+   }
+   else if(hand == MAG_HAND_RIGHT) {
+     tap_stop_message(ch, hand, magic->rh_tapping);
+     magic->rh_tapping = MAG_ACTION_NONE;
+   }
+ }
+ 
+ 
+ //
+ // Show the message that accompanies a hand gesture
+ //
+ void show_mag_action_message(CHAR_DATA *ch, char hand, char action) {
+   if(mag_action_is_tap(action))
+     tap_start_message(ch, hand, action);
+   else {
+ 
+   }
+ }
+ 
+ 
+ void do_mag_effect(CHAR_DATA *ch, CHAR_DATA *vict, int effect) {
+   switch(effect) {
+   case MAG_EFFECT_FIREBOLT:
+   case MAG_EFFECT_ACIDBOLT:
+   case MAG_EFFECT_STONESPEAR:
+   case MAG_EFFECT_SHOCK:
+     send_to_char(ch, "You cast a basic spell at %s!\r\n", 
+ 		 (vict ? charGetName(vict) : "nobody"));
+     break;
+ 
+     // nothing
+   default: 
+     break;
+   }
+ }
+ 
+ 
+ void do_magic_action(CHAR_DATA *ch, CHAR_DATA *vict, const char *action) {
+   char lh_action = MAG_ACTION_NONE;
+   char rh_action = MAG_ACTION_NONE;
+   bool lh_acting = FALSE; // have we made a lh/rh action this turn?
+   bool rh_acting = FALSE;
+ 
+   // first, look up our magic information
+   MAG_DATA *magic = mapGet(mag_map, ch);
+ 
+   // if one doesn't exist, create it and add it to our magic map
+   // also toss it into the event queue
+   if(magic == NULL) {
+     magic = newMagic();
+     mapPut(mag_map, ch, magic);
+     start_event(ch, MAG_EVENT_DELAY, 
+ 		handle_mag_event, check_mag_event_involvement, 
+ 		magic, NULL);
+   }
+ 
+   // parse our action and add it to the magic data
+   while(*action) {
+     bool one_action_lh = FALSE;
+     bool one_action_rh = FALSE;
+     char act           = '\0';
+ 
+     // first, parse the hand(s)
+     if(*action == MAG_HAND_LEFT || *action == MAG_HAND_BOTH)
+       one_action_lh = TRUE;
+     if(*action == MAG_HAND_RIGHT || *action == MAG_HAND_BOTH)
+       one_action_rh = TRUE;
+ 
+     // check if the character has tried two actions with one hand
+     if((one_action_lh && lh_acting) || (one_action_rh && rh_acting)) {
+       send_to_char(ch,"You can only perform one action with a hand at a time!\r\n");
+       return;
+     }
+ 
+     // we didn't parse a hand ... oops!
+     if(!one_action_lh && !one_action_rh) {
+       send_to_char(ch, "Your hands get all tied, and you fail to us your magic!\r\n");
+       return;
+     }
+     
+     action++;
+     // now parse the action
+     switch(*action) {
+     case MAG_ACTION_TAP:       act = MAG_ACTION_TAP;       break;
+     case MAG_ACTION_DISMISS:   act = MAG_ACTION_NONE;      break;
+     case MAG_ACTION_PUSH:      act = MAG_ACTION_PUSH;      break;
+     case MAG_ACTION_ARC:       act = MAG_ACTION_ARC;       break;
+     case MAG_ACTION_LOWER:     act = MAG_ACTION_LOWER;     break;
+     case MAG_ACTION_WIGGLE:    act = MAG_ACTION_WIGGLE;    break;
+     case MAG_ACTION_SNAP:      act = MAG_ACTION_SNAP;      break;
+     case MAG_ACTION_PALM:      act = MAG_ACTION_PALM;      break;
+     case MAG_ACTION_FINGER:    act = MAG_ACTION_FINGER;    break;
+     case MAG_ACTION_TAP_NONE:  act = MAG_ACTION_NONE;      break;
+     case MAG_ACTION_TAP_FIRE:  act = MAG_ACTION_TAP_FIRE;  break;
+     case MAG_ACTION_TAP_WATER: act = MAG_ACTION_TAP_WATER; break;
+     case MAG_ACTION_TAP_EARTH: act = MAG_ACTION_TAP_EARTH; break;
+     case MAG_ACTION_TAP_AIR:   act = MAG_ACTION_TAP_AIR;   break;
+     default:
+       send_to_char(ch, "You try to make a gesture, but it had no magical significance.\r\n");
+       return;
+     }
+     action++;
+ 
+     // if we're trying to tap something, figure out what action it is
+     if(act == MAG_ACTION_TAP) {
+       switch(*action) {
+       case MAG_TAP_NONE:  act = MAG_ACTION_NONE;      break;
+       case MAG_TAP_FIRE:  act = MAG_ACTION_TAP_FIRE;  break;
+       case MAG_TAP_WATER: act = MAG_ACTION_TAP_WATER; break;
+       case MAG_TAP_EARTH: act = MAG_ACTION_TAP_EARTH; break;
+       case MAG_TAP_AIR:   act = MAG_ACTION_TAP_AIR;   break;
+       default:
+ 	send_to_char(ch, "You try to tap into a magic source, but fail!\r\n");
+ 	break;
+       }
+       action++;
+     }
+ 
+     // now that we've got the action, pop it into the hand it belongs in
+     // and note what hand we used to perform the action
+     if(one_action_lh) {
+       char *ptr = magic->lh_actions;
+       magic->lh_actions = malloc(sizeof(char) * (strlen(ptr) + 1));
+       sprintf(magic->lh_actions, "%s%c", ptr, act);
+       free(ptr);
+       lh_acting = TRUE;
+       lh_action = act;
+     }
+     if(one_action_rh) {
+       char *ptr = magic->rh_actions;
+       magic->rh_actions = malloc(sizeof(char) * (strlen(ptr) + 1));
+       sprintf(magic->rh_actions, "%s%c", ptr, act);
+       free(ptr);
+       rh_acting = TRUE;
+       rh_action = act;
+     }
+   }
+ 
+ 
+   // if we're using a hand that we were tapping with, stop the tapping
+   if(lh_acting && magic->lh_tapping != MAG_ACTION_NONE)
+     stop_tapping(ch, magic, MAG_HAND_LEFT);
+   if(rh_acting && magic->rh_tapping != MAG_ACTION_NONE)
+     stop_tapping(ch, magic, MAG_HAND_RIGHT);
+ 
+ 
+   // do something about seeing if we're tapping mana
+   if(lh_acting && mag_action_is_tap(lh_action)) {
+     start_tapping(ch, magic, MAG_HAND_LEFT, lh_action);
+     lh_acting = FALSE;
+     // now, free our history ... nothing starts with a tap
+     free(magic->lh_actions); magic->lh_actions = strdup("");
+   }
+   if(rh_acting && mag_action_is_tap(rh_action)) {
+     start_tapping(ch, magic, MAG_HAND_RIGHT, rh_action);
+     rh_acting = FALSE;
+     // now, free our history ... nothing starts with a tap
+     free(magic->rh_actions); magic->rh_actions = strdup("");
+   }
+ 
+   // based on the mana we've accumulated, figure out what table to use
+   MAG_EFFECT *table = get_mag_table(magic);
+ 
+   // now, see if we've created any magical effects
+   if(table && lh_acting) {
+     int entry = check_for_mag_effect(table, magic->lh_actions);
+     do_mag_effect(ch, vict, table[entry].effect);
+   }
+   if(table && rh_acting) {
+     int entry = check_for_mag_effect(table, magic->rh_actions);
+     do_mag_effect(ch, vict, table[entry].effect);
+   }
+ }
+ 
+ 
+ COMMAND(cmd_cast) {
+   char action[SMALL_BUFFER];
+ 
+   trim(arg);
+   // make sure it's not white space
+   if(!arg || !*arg) {
+     send_to_char(ch, "What were you trying to do?\r\n");
+     return;
+   }
+ 
+   // separate the action from the target
+   arg = one_arg(arg, action);
+ 
+   // look for a target if we need to
+   int found_type = FOUND_NONE;
+   CHAR_DATA *vict = NULL;
+   if(*arg)
+       vict = generic_find(ch, arg, FIND_TYPE_CHAR, 
+ 			  FIND_SCOPE_ROOM | FIND_SCOPE_VISIBLE,
+ 			  FALSE, &found_type);
+   do_magic_action(ch, vict, action);
+ }
diff -crN nakedmudv1.4/src/magic.h nakedmudv1.5/src/magic.h
*** nakedmudv1.4/src/magic.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/magic.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,102 ----
+ #ifndef __MAGIC_H
+ #define __MAGIC_H
+ //*****************************************************************************
+ //
+ // magic.h
+ //
+ // A little magic system that has similarities to Richard Bartle's Spellbinder
+ // (http://www.mud.co.uk/richard/spellbnd.htm). Players chain gestures 
+ // together to make magical effects happen. The system is a little bit 
+ // different, in that players have to draw on power from different sources 
+ // (fire, water, earth, air) before they can cast spells. They can combine
+ // powers from different sources to make more elaborate powers (e.g. fire +
+ // earth = magma). Other differences exist; for instance, this magic system
+ // is realtime, whereas Bartle's is turn-based. Characters have to "spend"
+ // and "tap" magic power, whereas in Bartle's game, magic did not have a source
+ // one had to draw into, or magic power one had to spend.
+ //
+ //*****************************************************************************
+ 
+ #define MAG_ACTION_NONE       '\0' // used to signify that no action is taken
+ 
+ #define MAG_HAND_LEFT         'l'  // perform action with left hand
+ #define MAG_HAND_RIGHT        'r'  // perform action with right hand
+ #define MAG_HAND_BOTH         'b'  // perform action with both hands
+ #define MAG_HAND_CLAP         'c'  // special marker - clap hands together
+ 
+ #define MAG_ACTION_TAP        't'  // tap into a specified energy source
+ #define MAG_ACTION_TAP_NONE   'N'  // tap nothing (dismiss)
+ #define MAG_ACTION_TAP_FIRE   'F'  // tap fire
+ #define MAG_ACTION_TAP_WATER  'W'  // tap water
+ #define MAG_ACTION_TAP_EARTH  'E'  // tap earth
+ #define MAG_ACTION_TAP_AIR    'A'  // tap air
+ 
+ #define MAG_ACTION_DISMISS    'd'  // dismiss the magic being tapped in hand
+ #define MAG_ACTION_PUSH       'p'  // push hand outward
+ #define MAG_ACTION_ARC        'a'  // raise hand upwards
+ #define MAG_ACTION_LOWER      'l'  // lower hand downwards
+ #define MAG_ACTION_WIGGLE     'w'  // wiggle fingers
+ #define MAG_ACTION_SNAP       's'  // snap fingers
+ #define MAG_ACTION_PALM       'u'  // upraised palm
+ #define MAG_ACTION_FINGER     'f'  // pointed finger
+ 
+ #define MAG_TAP_NONE          'n'
+ #define MAG_TAP_FIRE          'f'  
+ #define MAG_TAP_WATER         'w'
+ #define MAG_TAP_EARTH         'e'  
+ #define MAG_TAP_AIR           'a'
+ 
+ 
+ //      EFFECT                                 HAND MOVEMENT      WHEN TAPPING
+ #define MAG_EFFECT_NONE               (-1)
+ #define MAG_EFFECT_FIREBOLT             0   // s-f                fire
+ #define MAG_EFFECT_ACIDBOLT             1   // s-f                water
+ #define MAG_EFFECT_STONESPEAR           2   // s-f                earth
+ #define MAG_EFFECT_SHOCK                3   // s-f                air
+ 
+ 
+ //
+ // initialize the magic system
+ //
+ void init_magic();
+ 
+ 
+ //
+ // Interrupt the character's magic info
+ //
+ void interrupt_magic(CHAR_DATA *ch);
+ 
+ 
+ //
+ // perform an action. If an effect results, then return which effect it is.
+ // Actions have a syntax to them which must be followed. It goes:
+ //   hand, action, element (if the action is to tap).
+ //
+ // More than one action can be performed at a time, if they were done on
+ // separate hands.
+ //
+ // Here are some example, valid actions:
+ //   lw                           wiggle left fingers
+ //   rtf                          tap into fire with the right hand
+ //   ba                           arc both hands upwards
+ //   lara                         arc both hands upwards
+ //   ltwru                        tap water with left hand, raise right palm up
+ //   ltwrd                        tap water w/ left hand, dismiss magic in right
+ //   ltwrtn                       same as above
+ //
+ //int do_magic_action(CHAR_DATA *ch, const char *action);
+ 
+ 
+ 
+ //
+ // Make the character perform the specified action on the victim
+ //
+ //void do_mag_effect(CHAR_DATA *ch, CHAR_DATA *vict, int effect);
+ 
+ 
+ //
+ // The entrypoint into the magic system
+ //
+ COMMAND(cmd_cast);
+ 
+ #endif // __MAGIC_H
diff -crN nakedmudv1.4/src/Makefile nakedmudv1.5/src/Makefile
*** nakedmudv1.4/src/Makefile	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/Makefile	2010-11-01 15:54:17.000000000 -0500
***************
*** 14,20 ****
  CC = gcc
  
  # the modules we have installed
! MODULES := time alias char_vars socials olc scripts
  
  # flags to use during compilation
  C_FLAGS := -Wall -g -ggdb -O2
--- 14,20 ----
  CC = gcc
  
  # the modules we have installed
! MODULES := time alias char_vars socials olc scripts help
  
  # flags to use during compilation
  C_FLAGS := -Wall -g -ggdb -O2
***************
*** 26,41 ****
  SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
  	   action.c mccp.c save.c socket.c io.c strings.c event.c \
  	   \
! 	   cmd_comm.c cmd_manip.c cmd_misc.c \
  	   \
! 	   text_editor.c builder.c admin.c help.c \
  	   \
! 	   items.c races.c log.c auxiliary.c \
  	   \
  	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
  	   zone.c dialog.c room_reset.c \
  	   \
! 	   list.c property_table.c hashtable.c hashmap.c storage.c
  
  
  # include the description for each module. These will add to SRC
--- 26,41 ----
  SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c movement.c \
  	   action.c mccp.c save.c socket.c io.c strings.c event.c \
  	   \
! 	   cmd_comm.c cmd_manip.c cmd_misc.c cmd_admin.c cmd_builder.c \
  	   \
! 	   text_editor.c races.c \
  	   \
! 	   items.c log.c auxiliary.c \
  	   \
  	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
  	   zone.c dialog.c room_reset.c \
  	   \
! 	   list.c property_table.c hashtable.c hashmap.c storage.c set.c
  
  
  # include the description for each module. These will add to SRC
diff -crN nakedmudv1.4/src/module.mk nakedmudv1.5/src/module.mk
*** nakedmudv1.4/src/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/module.mk	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ SRC += races/races.c
diff -crN nakedmudv1.4/src/movement.c nakedmudv1.5/src/movement.c
*** nakedmudv1.4/src/movement.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/movement.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 9,20 ****
  #include "mud.h"
  #include "character.h"
  #include "world.h"
  #include "room.h"
  #include "exit.h"
  #include "movement.h"
  #include "handler.h"
  #include "inform.h"
- #include "builder.h"
  #include "utils.h"
  #include "items.h"
  #include "object.h"
--- 9,20 ----
  #include "mud.h"
  #include "character.h"
  #include "world.h"
+ #include "zone.h"
  #include "room.h"
  #include "exit.h"
  #include "movement.h"
  #include "handler.h"
  #include "inform.h"
  #include "utils.h"
  #include "items.h"
  #include "object.h"
***************
*** 36,42 ****
  		 exitGetName(exit));
    else {
      if(*exitGetSpecLeave(exit))
!       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
  	      exitGetSpecLeave(exit));
      else if(dir != DIR_NONE)
        send_around_char(ch, TRUE, "%s leaves %s.\r\n",
--- 36,42 ----
  		 exitGetName(exit));
    else {
      if(*exitGetSpecLeave(exit))
!       message(ch, NULL, NULL, NULL, TRUE, TO_ROOM | TO_NOTCHAR,
  	      exitGetSpecLeave(exit));
      else if(dir != DIR_NONE)
        send_around_char(ch, TRUE, "%s leaves %s.\r\n",
***************
*** 63,68 ****
--- 63,110 ----
  }
  
  
+ bool try_buildwalk(CHAR_DATA *ch, int dir) {
+   ZONE_DATA *zone = worldZoneBounding(gameworld, roomGetVnum(charGetRoom(ch)));
+   
+   if(!canEditZone(zone, ch))
+     send_to_char(ch, "You are not authorized to edit this zone.\r\n");
+   else if(roomGetExit(charGetRoom(ch), dir))
+     send_to_char(ch, "You try to buildwalk %s, but a room already exists in that direction!\r\n", dirGetName(dir));
+   else if(!zone) {
+     send_to_char(ch, "The room you are in is not attached to a zone!\r\n");
+     log_string("ERROR: %s tried to buildwalk %s, but room %d was not in a zone!", charGetName(ch), dirGetName(dir), roomGetVnum(charGetRoom(ch)));
+   }
+   else {
+     room_vnum vnum = getFreeRoomVnum(zone);
+     if(vnum == NOWHERE)
+       send_to_char(ch, 
+ 		   "Zone #%d has no free rooms left. "
+ 		   "Buildwalk could not be performed.\r\n", zoneGetVnum(zone));
+     else {
+       char desc[MAX_BUFFER];
+       ROOM_DATA *new_room = newRoom();
+       roomSetVnum(new_room, vnum);
+ 
+       roomSetName(new_room, "A New Buildwalk Room");
+       sprintf(desc, "This room was created by %s.\r\n", charGetName(ch));
+       roomSetDesc(new_room, desc);
+ 
+       zoneAddRoom(zone, new_room);
+       roomDigExit(charGetRoom(ch), dir, vnum);
+       roomDigExit(new_room, dirGetOpposite(dir), 
+ 		  roomGetVnum(charGetRoom(ch)));
+       try_move(ch, dir, NULL);
+       return TRUE;
+ 
+       // save the changes... this will get costly as our world gets bigger.
+       // But that should be alright once we make zone saving a bit smarter
+       worldSave(gameworld, WORLD_PATH);
+     }
+   }
+   return FALSE;
+ }
+ 
+ 
  bool try_move(CHAR_DATA *ch, int dir, const char *specdir) {
    EXIT_DATA *exit = NULL;
    if(dir != DIR_NONE)      
***************
*** 84,92 ****
      ROOM_DATA *old_room = charGetRoom(ch);
      bool success = try_exit(ch, exit, dir);
      if(success) {
!       try_exit_script(ch, old_room, exit, 
  		      (dir != DIR_NONE ? dirGetName(dir) : specdir));
!       try_enterance_script(ch, charGetRoom(ch), exit, 
  			   (dir != DIR_NONE ? dirGetName(dir) : specdir));
      }
      return success;
--- 126,134 ----
      ROOM_DATA *old_room = charGetRoom(ch);
      bool success = try_exit(ch, exit, dir);
      if(success) {
!       try_exit_script(ch, old_room, 
  		      (dir != DIR_NONE ? dirGetName(dir) : specdir));
!       try_enterance_script(ch, charGetRoom(ch),
  			   (dir != DIR_NONE ? dirGetName(dir) : specdir));
      }
      return success;
diff -crN nakedmudv1.4/src/movement.h nakedmudv1.5/src/movement.h
*** nakedmudv1.4/src/movement.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/movement.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 28,32 ****
--- 28,37 ----
  //
  bool try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir);
  
+ //
+ // Try creating a new room in the specified direction, drawn from the
+ // zone we're currently in.
+ //
+ bool try_buildwalk(CHAR_DATA *ch, int dir);
  
  #endif // __MOVEMENT_H
diff -crN nakedmudv1.4/src/mud.c nakedmudv1.5/src/mud.c
*** nakedmudv1.4/src/mud.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/mud.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 24,30 ****
  
  void save_mud_settings() {
    STORAGE_SET *set = storage_read(MUD_DATA);
!   store_int(set, "puid", top_char_uid, NULL);
    storage_write(set, MUD_DATA);
    storage_close(set);
  }
--- 24,30 ----
  
  void save_mud_settings() {
    STORAGE_SET *set = storage_read(MUD_DATA);
!   store_int(set, "puid", top_char_uid);
    storage_write(set, MUD_DATA);
    storage_close(set);
  }
